from xml.sax.saxutils import escape as xmlEscape
from httplib import HTTPConnection
from urllib import urlopen
from lxml.etree import parse, tostring, ElementTree
import sys

## oai bron van de enrichments ##
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=ListRecords&metadataPrefix=neeo_didl"
# docid not found
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=urn:NBN:nl:ui:15-1765/7652&metadataPrefix=neeo_didl"
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=urn:NBN:nl:ui:15-1765/12981&metadataPrefix=neeo_didl"
# geen jels
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=info:hdl:2013/12413&metadataPrefix=neeo_didl"
url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=urn:hdl:123456789/198099&metadataPrefix=neeo_didl"
# geen jels
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=info:hdl:2013/12519&metadataPrefix=neeo_didl"
# geen jels
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=urn:nbn:nl:ui:12-154977&metadataPrefix=neeo_didl"
# geen jels
#url = "http://test2.ubib.eur.nl/neeo/enrichment?verb=GetRecord&identifier=info:hdl:2013/12123&metadataPrefix=neeo_didl"

## reader die info geef#t over het document waaraan de ddi wordt toegevoegd ##
baseurl = "http://localhost:8084/sru"

action = "replace"
#action = "delete"

def send(recordUpdate):
    ## writer waarnaar de enrichment wordt gestuurd ##
    connection = HTTPConnection('localhost', '9999')
#    connection = HTTPConnection('localhost', '7074')
    connection.putrequest("POST", "")
#    connection.putrequest("POST", "/update")
    connection.putheader("Host", "localhost")
    connection.putheader("Content-Type", "text/xml; charset=\"utf-8\"")
    connection.putheader("Content-Length", str(len(recordUpdate)))
    connection.endheaders()
    connection.send(recordUpdate)

    result = connection.getresponse()
    res = result.read()
    print res
    if res.find("<ucp:operationStatus>success</ucp:operationStatus>")>0:
        return "--success"
    else: return "--fail"

def makeDocument(meta, jel):
    return """<document xmlns="http://meresco.com/namespace/harvester/document">
  <part name="meta">%(m)s</part>
  <part name="metadata">%(c)s</part>
</document>""" % {'m': xmlEscape(meta), 'c': xmlEscape(jel)}

def makeRequest(action, repository, recordIdentifier, document):
    if action == "replace":
        re = """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="http://www.loc.gov/zing/srw/" xmlns:ucp="http://www.loc.gov/ucp">
 <srw:version>1.0</srw:version>
 <ucp:action>info:srw/action/1/replace</ucp:action>
 <ucp:recordIdentifier>%(repository)s:%(recordIdentifier)s</ucp:recordIdentifier>
 <srw:record>
  <srw:recordPacking>xml</srw:recordPacking>
  <srw:recordSchema>document</srw:recordSchema>
  <srw:recordData>%(document)s</srw:recordData>
 </srw:record>
</srw:updateRequest>"""
    elif action == "delete":
        re = """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="http://www.loc.gov/zing/srw/" xmlns:ucp="http://www.loc.gov/ucp">
 <srw:version>1.0</srw:version>
 <ucp:action>info:srw/action/1/delete</ucp:action>
 <ucp:recordIdentifier>%(repository)s:%(recordIdentifier)s</ucp:recordIdentifier>
</srw:updateRequest>"""
    # the request is finished by replacing the variables by its values
    return re %locals()

def makeMeta(collection, repositoryGroup, repository, recordIdentifier, parts):
    p = ""
    if parts:
        for part in parts:
            if part == "jel": continue
            p += "<meta:part>" + part + "</meta:part>"
    return """<meta:meta xmlns:meta="http://meresco.com/namespace/harvester/meta">
  <meta:upload><id>%(repository)s:%(recordIdentifier)s</id></meta:upload>
  <meta:record>
    <meta:id>%(recordIdentifier)s</meta:id>
  </meta:record>
  <meta:repository>
    <meta:id>%(repository)s</meta:id>
    <meta:repositoryGroupId>%(repositoryGroup)s</meta:repositoryGroupId>
    <meta:collection>%(collection)s</meta:collection>
  </meta:repository>
  <meta:parts>
    <meta:part>jel</meta:part>
    %(p)s
  </meta:parts>
</meta:meta>""" %locals()

def makeMods(jels):
    classifications=""
    for jel in jels:
        classifications += "\n  " + tostring(jel).strip()
    return """<mods:mods version="3.2" xmlns:mods="http://www.loc.gov/mods/v3">%s
</mods:mods>""" % classifications

ns = {'didl': 'urn:mpeg:mpeg21:2002:02-DIDL-NS',
      'dii': 'urn:mpeg:mpeg21:2002:01-DII-NS',
      'meta':'http://meresco.com/namespace/harvester/meta',
      'mods': 'http://www.loc.gov/mods/v3',
      'srw':'http://www.loc.gov/zing/srw/'}

xml = parse(urlopen(url))
DIDLs = xml.xpath("//didl:DIDL", ns)
for DIDL in DIDLs:
    DIDL = ElementTree(DIDL)
    #print tostring(DIDL, pretty_print=True)
    docid = DIDL.xpath("/didl:DIDL/didl:Descriptor/didl:Statement/dii:Identifier/text()", ns)[0]
    print docid

    collection = "enrichment"
    repositoryGroupId = "enrichment"
    repository = "enrichment"
    recordIdentifier = docid
    parts = None

    ## update-record voorbereiden ##
    meta = makeMeta(collection, repositoryGroupId, repository, recordIdentifier, parts)
    document = makeDocument(meta, tostring(xml) )
    recordUpdate = makeRequest(action, repository, recordIdentifier, document)
    #print recordUpdate

    ## update-record verzenden ##
    res = send(recordUpdate)
